<template>
  <div>

    <!-- Table Container Card -->
    <b-card
      title="Lista de proyectos"
    >

       <div class="m-2">

        <b-row>
          <b-col
            cols="12"
            md="6"
            class="d-flex align-items-center justify-content-start mb-1 mb-md-0"
          >
          </b-col>

          <b-col
            cols="12"
            md="6"
          >
            <div class="d-flex align-items-center justify-content-end">
              <b-form-input
                v-model="searchQuery"
                class="d-inline-block mr-1"
                placeholder="Buscar..."
              />
              <b-button variant="primary" :to="{ name: 'apps-projects-add'}">
                <span class="text-nowrap">Agregar Proyecto
                </span>
              </b-button>
            </div>
          </b-col>
        </b-row>

      </div>

      <b-table
        class="position-relative"
        :items="projects"
        responsive
        :fields="tableColumns"
        :filter="searchQuery"
        primary-key="id"
        show-empty
        sticky-header
        empty-text="No se encontraron registros"
      >

        <template #cell(Acciones)="data">
          <b-dropdown
            variant="link"
            no-caret
          >

            <template #button-content>
              <feather-icon
                icon="MoreVerticalIcon"
                size="16"
                class="align-middle text-body"
              />
            </template>
            <b-dropdown-item :to="{ name: 'apps-projects-view', params: { id: data.item.id} }">
              <feather-icon icon="FileTextIcon" />
              <span class="align-middle ml-50">Detalles</span>
            </b-dropdown-item>

            <b-dropdown-item v-if="hasPermission('edit_projects')"  :to="{ name: 'apps-projects-edit', params: { id: data.item.id } }">
              <feather-icon icon="EditIcon" />
              <span class="align-middle ml-50">Editar</span>
            </b-dropdown-item>

            <b-dropdown-item   v-if="hasPermission('delete_projects')">
              <feather-icon icon="TrashIcon" />
               <span @click="deleteProject(data.item.id)" class="align-middle ml-50">Eliminar</span>
            </b-dropdown-item>
          </b-dropdown> 
        </template>

      </b-table> 
      
    </b-card>
  </div>
</template>

<script>
import {
  BCard, BRow, BCol, BFormInput, BButton, BTable, BMedia, BAvatar, BLink,
  BBadge, BDropdown, BDropdownItem, BPagination,
} from 'bootstrap-vue'


export default {
  components: {
    BCard,
    BRow,
    BCol,
    BFormInput,
    BButton,
    BTable,
    BMedia,
    BAvatar,
    BLink,
    BBadge,
    BDropdown,
    BDropdownItem,
    BPagination,
  },
  data() {
    return {
      projects:[],
      tableColumns:[
        { key: 'name', label: "Proyecto", sortable: true },
        { key: 'user_client.name', label: "Cliente", sortable: true },
        { key: 'user_manager.name', label: "Encargado", sortable: true },
        { key: 'Acciones' },
      ],
      searchQuery:'',

    }
  },
  methods:{
    getProjects(){
      this.$http.get('project').then(res=>{
        this.projects = res.data.projects
        console.log(this.projects);
      }).catch(err=>{
        console.log(err);
      })
    },
    deleteProject(id){

       this.$swal({
        title: '¿Está seguro de eliminar el registro?',
        text: "No podrás revertir esto!",
        icon: 'warning',
        showCancelButton: true,
        confirmButtonText: 'Si, eliminar!',
        customClass: {
          confirmButton: 'btn btn-primary',
          cancelButton: 'btn btn-outline-danger ml-1',
        },
        buttonsStyling: false,

      }).then(result => {
        if (result.value) {
          let parametros = {id: id};
          this.$http.get("project/delete", { params: parametros }).then((res) => {
            if(res.data.message === 'eliminado'){
              this.$swal({
                icon: 'success',
                title: 'Eliminado!',
                text: 'El registro ha sido eliminado.',
                customClass: {
                  confirmButton: 'btn btn-success',
                },
              })
              this.getProjects()
            }else if(res.data.message === 'No se encontro el registro'){
              this.$swal({
                title: 'Error!',
                text: ' No se pudo eliminar!',
                icon: 'error',
                customClass: {
                  confirmButton: 'btn btn-primary',
                },
                buttonsStyling: false,
              })
            }else if(res.data.message === 'haveActivities'){
              this.$swal({
                title: 'Error!',
                text: ' Este proyecto cuenta con una o más actividades activas, no se pudo eliminar',
                icon: 'error',
                customClass: {
                  confirmButton: 'btn btn-primary',
                },
                buttonsStyling: false,
              })
            }
            
          }).catch(err=>{
            console.log(err);
          })

          
        } else if (result.dismiss === 'cancel') {
          this.$swal({
            title: 'Cancelado',
            text: 'El registro esta a salvo :)',
            icon: 'error',
            customClass: {
              confirmButton: 'btn btn-success',
            },
          })
        }
      })
    }
  },
  mounted(){
    this.getProjects() 
    
  },
}
</script>

<style lang="scss" scoped>
.per-page-selector {
  width: 90px;
}
</style>

<style lang="scss">
@import '@core/scss/vue/libs/vue-select.scss';
b-table{
  height:500px;
}
</style>

